var mgBMSimpleArray =
{
  RDF : Components.classes["@mozilla.org/rdf/rdf-service;1"]
        .getService(Components.interfaces.nsIRDFService),

  RDFCUtils : Components.classes["@mozilla.org/rdf/container-utils;1"]
              .getService()
              .QueryInterface(Components.interfaces.nsIRDFContainerUtils),

  NS : "http://optimoz.mozdev.org/gestures-rdf#",

  mgPref : Components.classes["@mozilla.org/preferences-service;1"]
          .getService(Components.interfaces.nsIPrefService)
          .getBranch("mozgest."),

  init : function(Res, condition, component)
  {
     this.mArray = new Array()
     this.length = 0

     try
     {
       this.profile = Components.classes['@mozilla.org/file/directory_service;1']
                      .getService(Components.interfaces.nsIProperties);
       this.pPath = this.profile.get('ProfD', Components.interfaces.nsILocalFile)
       this.pPath.append("mousegestures.rdf")

       this.fHandler = Components.classes["@mozilla.org/network/io-service;1"]
                      .getService(Components.interfaces.nsIIOService);

       this.userDS = this.RDF
                     .GetDataSourceBlocking(this.fHandler.newFileURI(this.pPath).spec);
     } catch (e) {return 0}

     this.Res = Res;
     this.condition = condition;
     this.component = component;

     return this.readGestures();
  },

  readGestures : function()
  {
    // instantiate a container object and its root node
    var mappingsContainer = this.newContainer();
    var rootnode = this.RDF.GetResource("urn:mozgest:mappings:" + this.component);

    try {
      mappingsContainer.Init(this.userDS, rootnode);
    } catch (e) {
      return 0;
    }

    var enumerator = mappingsContainer.GetElements();
    while (enumerator.hasMoreElements())
    {
      var mapping = enumerator.getNext()
                    .QueryInterface(Components.interfaces.nsIRDFResource);

      var entry = new this.Mapping();
      entry.resource = mapping.Value;
      entry.appearance = this.getProperty(mapping, "appearance");
      entry.code = this.getProperty(mapping, "code");
      entry.countBase = Math.abs(this.getProperty(mapping, "count")) || 0;
      entry.custom = decodeURI(this.getProperty(mapping, "custom"));
      entry.bmOpenIn = this.getProperty(mapping, "bmOpenIn");
      entry.name = this.getProperty(mapping, "name");
      entry.func = this.getProperty(mapping, "function");

      if (eval("entry." + this.condition) == this.Res)
      {
         this.length += 1;
         this.mArray[entry.code] = entry;
      }
    }
    return this.length;
  },

  /*** convenience functions for RDF access ***/

  newContainer : function()
  {
    return Components.classes['@mozilla.org/rdf/container;1'].createInstance()
           .QueryInterface(Components.interfaces.nsIRDFContainer);
  },

  getProperty : function (obj, propName)
  {
    // get nsIRDFNode
    var literal = this.userDS.GetTarget(obj,
                              this.RDF.GetResource(this.NS + propName), true);
    if (literal) {
      // convert to nsIRDFLiteral and get the value
      return literal.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
    } else {
      return null;
    }
  },

  Mapping : function()
  {
    this.appearance = null;
    this.code = null;
    this.countBase = null;
    this.custom = null;
    this.bmOpenIn = null;
    this.func = null;
    this.name = null;
    this.resource = null;
  }

}