var doc;
var mgHistoryItem = new Array()
var templateCell1;
var templateCell2;
var templateImage;
var rowEven;
var mgSelected = new Array();

function Startup() {
  doc=document.getElementById("theFrame").contentDocument;
  document.getElementById(parent.mgSideBarSort).setAttribute('checked',true);

  // clone gesture table
  var counts = new Array();
  for (var p in parent.gesturesTable) {
    counts.push(parent.gesturesTable[p]);
  }

  if (parent.mgSideBarSort == "sortByName")
     counts.sort(function(a,b) {return ((a.name.toLowerCase())>(b.name.toLowerCase()) ? 1 : -1)} );

  if (parent.mgSideBarSort == "sortByUsage")
     counts.sort(function(a,b) {return ((a.countBase+a.countCur)>(b.countBase+b.countCur) ? 1 : -1)} );

  rowEven = true;
  templateCell1 = doc.createElement("td");
  templateCell1.setAttribute("class", "action");;
  templateCell2 = doc.createElement("td");
  templateCell2.setAttribute("class", "gesture");;
  templateImage = doc.createElement("img");
  templateImage.setAttribute("width", 10);
  templateImage.setAttribute("height", 10);
  templateImage.setAttribute("style", "margin-right: 1px;");

  for (var i=0; i < counts.length; i++) {
    if (counts[i].code.indexOf(":") == 0) {
       if (!parent.rockersEnabled ||
           (!parent.mgWheelRockers && isNaN(counts[i].code.substring(2))))
          continue;
    }
    createCell(counts[i]);
  }
}

function createCell(mgGest) {
  var aGest = (mgGest.appearance) ? mgGest.appearance : mgGest.code;
  var aAction = mgGest.name;
  var classStr = (rowEven ? 'even' : 'odd');
  rowEven = !rowEven;
  var row = doc.createElement("tr");
  row.setAttribute("class", classStr);
  row.mgMapping = aGest;
  row.mgWindowType = mgGest.component;
  row.mgResource = mgGest.resource;
  if (mgGest.code.indexOf("UUUUUU") == 0)
    row.setAttribute("isPatch", true);
  row.setAttribute("action", aAction)
  row.addEventListener("contextmenu", function (e){
                       mgSelected[0] = this.mgResource;
                       mgSelected[1] = this.mgWindowType;}, true)
  var cell1 = templateCell1.cloneNode(false);
  cell1.appendChild(doc.createTextNode(aAction));
  var cell2 = templateCell2.cloneNode(false);
  row.appendChild(cell1);
  row.appendChild(cell2);
  doc.getElementById("mappings").appendChild(row);
  if (parent.mgClassicSideBar)
    renderClassic(aGest, cell2);
  else
    renderModern(aGest, cell2);
}

function renderClassic(aGest, targetNode) {
  if (aGest.charAt(0) != ":") {
    var plusFlag = false;
    for(var i=0; i < aGest.length; i++) {
      if(aGest[i]=='*') {
        plusFlag = true;
        continue;
      }
      var imgUrl = "chrome://mozgest/content/sidebar/X.png";
      imgUrl = imgUrl.replace(/X/,aGest[i]);
      var image = templateImage.cloneNode(false);
      image.setAttribute("src", imgUrl);
      if (plusFlag) {
        image.setAttribute("class", "link");
        plusFlag = false;
      }
      targetNode.appendChild(image);
    }
  }
  else
    targetNode.appendChild(document.createTextNode(aGest));
}

function renderModern(aGest, targetNode) {
  doc.defaultView.createGestureBox(aGest, targetNode);
}

function addObserver() {
  Components.classes["@mozilla.org/observer-service;1"]
            .getService(Components.interfaces.nsIObserverService)
            .addObserver(mgSidebarObserver, "mozgestControl", false);
}

function removeObserver() {
  Components.classes["@mozilla.org/observer-service;1"]
            .getService(Components.interfaces.nsIObserverService)
            .removeObserver(mgSidebarObserver, "mozgestControl");

  parent.mgPref.setCharPref("sideBarSort", parent.mgSideBarSort)
}

function reloadFrame(aID) {
  if (parent.mgSideBarSort != aID) {
     document.getElementById('theFrame').webNavigation.reload(0);
     parent.mgSideBarSort = aID
     parent.mgPref.setCharPref("sideBarSort", aID)
  }
}

function updateGestureHistory(target) {
  for (var x = 0; x < mgHistoryItem.length; x++)
      target.removeChild(mgHistoryItem[x]);

  for (x = 0; x < parent.gestureHistory.length; x++) {
      mgHistoryItem[x] = document.createElement('menuitem')
      mgHistoryItem[x].setAttribute('label', parent.gestureHistoryMSG[x])
      mgHistoryItem[x].setAttribute('acceltext', parent.gestureHistory[x])
      mgHistoryItem[x].setAttribute('disabled', true)
      mgHistoryItem[x].setAttribute('mgMenuItem', true)
      target.insertBefore(mgHistoryItem[x], document.getElementById("historyMore"));
  }
}

var mgSidebarObserver = {
  observe: function(subject, topic, data) {
    if (topic == "mozgestControl") {
      if (data == "mappingsUpdated") {
        setTimeout("document.getElementById('theFrame').webNavigation.reload(0)", 0);
      }
    }
  }
}

function showWebPage(pageUrl) {
  // determine locale
  var locale = null;
  try {
    locale = Components.classes["@mozilla.org/chrome/chrome-registry;1"]
                       .getService(Components.interfaces.nsIXULChromeRegistry)
                       .getSelectedLocale("global");
  } catch (e) {
  }
  if (locale != null) {
    pageUrl = pageUrl + "?language=" + locale;
  }

  //check for an existing browser window
  const kWindowMediatorContractID = "@mozilla.org/appshell/window-mediator;1";
  const kWindowMediatorIID = Components.interfaces.nsIWindowMediator;
  const kWindowMediator = Components.classes[kWindowMediatorContractID].getService(kWindowMediatorIID);
  var browserWindow = kWindowMediator.getMostRecentWindow("navigator:browser");
  if (browserWindow) {
    try {
      browserWindow.delayedOpenTab(pageUrl);
    }
    catch(e) {
      browserWindow.loadURI(pageUrl);
    }
  }
  else {
    window.open(pageUrl);
  }
}